"""
Utilities for logging, parallel execution
"""

import os
import logging

def do_setup(tool_name = None):
    
    out_directory = os.getcwd() + "/Stack3D_Logging/"
    if not os.path.exists(out_directory):
        os.makedirs(out_directory)
    if tool_name is not None:
        filename = out_directory + tool_name + ".log"
    else:
        filename = out_directory + "/root.log"
        
    logging.basicConfig(level=logging.DEBUG,
                format='%(asctime)s %(name)-12s %(levelname)-8s %(message)s',
                datefmt='%m-%d %H:%M',
                filename=filename,
                filemode='w')
    
    console = logging.StreamHandler()
    console.setLevel(logging.INFO)
    
    # set a format which is simpler for console use
    formatter = logging.Formatter('%(name)-12s: %(levelname)-8s %(message)s')
    
    # tell the handler to use this format
    console.setFormatter(formatter)
    
    # add the handler to the root logger
    logging.getLogger('').addHandler(console)
        
        